function p =portVal(sDate,eDate)
portfolio={'YHOO','MSFT','RAD','BAC','ORCL','FB','SIRI','AAPL','BTU'};

bizDays=busdays(sDate,eDate,'daily');
% datesStr=datestr(dates);
data=getYahooDailyData(portfolio,sDate,eDate, 'dd/mm/yyyy');
dates=table2array(data.YHOO(:,1));

%rebalancing
prevRebalance=1;
adjClose=zeros(length(dates),length(portfolio));

% for z=1:length(struct2cell(data))
%     dp=data.(portfolio{z});
%     adjClose(1:length(dates),z)=table2array(dp(1:length(dates),7));
% end

for z=1:length(struct2cell(data))
    dp=data.(portfolio{z});
    if height(dp)~=length(dates)
        difference=length(dates)-height(dp);
        adjClose(1:difference,z)=zeros(1,difference)*table2array(dp(1,7));
        adjClose(difference+1:length(dates),z)=table2array(dp(:,7));
    else
        adjClose(:,z)=table2array(dp(1:length(dates),7));
    end
end

sharesOutstanding=xlsread('Stocks.xlsx',2,'A2:I2');
sharesOutstanding=sharesOutstanding.'/1e11;

[m,n]=size(adjClose);
adjClose(m,:)=1;
for i=1:n
    for j=1:m
        marketCap(j,i)=adjClose(j,i).*sharesOutstanding(i);
    end
end

for k=1:m
    sumMarketCap(k,1)=sum(marketCap(k,:));
    oneInEach(k,1)=sum(adjClose(k,:));
end
sumEqualValue=struct('daily',zeros(m-1,1),'monthly',zeros(m-1,1),'quarterly',zeros(m-1,1),'weekly',zeros(m-1,1));
sumMarketValue=struct('daily',zeros(m-1,1),'monthly',zeros(m-1,1),'quarterly',zeros(m-1,1),'weekly',zeros(m-1,1));
sumOneinEach=struct('daily',zeros(m-1,1),'monthly',zeros(m-1,1),'quarterly',zeros(m-1,1),'weekly',zeros(m-1,1));

sharesInStockEqualValue=struct('daily',[],'monthly',[],'quarterly',[],'weekly',[]);
sharesInStockMarketCap=struct('daily',[],'monthly',[],'quarterly',[],'weekly',[]);
sharesInStockOneinEach=struct('daily',[],'monthly',[],'quarterly',[],'weekly',[]);
for date=1:m-1
    activeStocks=nnz(adjClose(date,:));
%     activeStocks=n;
    if date==1
        totalValueMarketCap=1;
        totalValueEqualValue=1;
        totalValueOneinEach=1;
        for stock=1:n
            if adjClose(date,stock)>0
                percentComp(date,stock)=marketCap(date,stock)./sumMarketCap(date);
                sharesInStockEqualValue.daily(date,stock)=(1/activeStocks)*totalValueEqualValue./adjClose(date,stock);
                sharesInStockEqualValue.monthly(date,stock)=(1/activeStocks)*totalValueEqualValue./adjClose(date,stock);
                sharesInStockEqualValue.quarterly(date,stock)=(1/activeStocks)*totalValueEqualValue./adjClose(date,stock);
                sharesInStockEqualValue.weekly(date,stock)=(1/activeStocks)*totalValueEqualValue./adjClose(date,stock);
                sharesInStockMarketCap.daily(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
                sharesInStockMarketCap.monthly(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
                sharesInStockMarketCap.quarterly(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
                sharesInStockMarketCap.weekly(date,stock)=percentComp(date,stock)*totalValueMarketCap./adjClose(date,stock);
                sharesInStockOneinEach.daily(date,stock)=1/sum(adjClose(1,:));
                sharesInStockOneinEach.monthly(date,stock)=1/sum(adjClose(1,:));
                sharesInStockOneinEach.quarterly(date,stock)=1/sum(adjClose(1,:));
                sharesInStockOneinEach.weekly(date,stock)=1/sum(adjClose(1,:));
            end
        end
    else
        [sharesInStockEqualValue.monthly, sharesInStockMarketCap.monthly, sharesInStockOneinEach.monthly] = rebalance_monthly(n,activeStocks,date,...
            dates,adjClose,marketCap,sumMarketCap, sharesInStockEqualValue.monthly,...
            sharesInStockMarketCap.monthly,sharesInStockOneinEach.monthly);
        [sharesInStockEqualValue.quarterly, sharesInStockMarketCap.quarterly, sharesInStockOneinEach.quarterly] = rebalance_3monthly(n,activeStocks,prevRebalance,...
            date,dates,adjClose,marketCap,sumMarketCap,sharesInStockEqualValue.quarterly,...
            sharesInStockMarketCap.quarterly,sharesInStockOneinEach.quarterly);
        [sharesInStockEqualValue.weekly, sharesInStockMarketCap.weekly, sharesInStockOneinEach.weekly] = rebalance_weekly(n,activeStocks,date,...
            dates,adjClose,marketCap,sumMarketCap,sharesInStockEqualValue.weekly,...
            sharesInStockMarketCap.weekly,sharesInStockOneinEach.weekly);
        [sharesInStockEqualValue.daily, sharesInStockMarketCap.daily, sharesInStockOneinEach.daily] = rebalance_daily(n,activeStocks,date,...
            adjClose,marketCap,sumMarketCap,sharesInStockEqualValue.daily,...
            sharesInStockMarketCap.daily,sharesInStockOneinEach.daily);
    end
    
    
    sumEqualValue.monthly(date)=sum(sharesInStockEqualValue.monthly(date,:).*adjClose(date,:));
    sumMarketValue.monthly(date)=sum(sharesInStockMarketCap.monthly(date,:).*adjClose(date,:));
    sumOneinEach.monthly(date)=sum(sharesInStockOneinEach.monthly(date,:).*adjClose(date,:));
    sumEqualValue.quarterly(date)=sum(sharesInStockEqualValue.quarterly(date,:).*adjClose(date,:));
    sumMarketValue.quarterly(date)=sum(sharesInStockMarketCap.quarterly(date,:).*adjClose(date,:));
    sumOneinEach.quarterly(date)=sum(sharesInStockOneinEach.quarterly(date,:).*adjClose(date,:));
    sumEqualValue.weekly(date)=sum(sharesInStockEqualValue.weekly(date,:).*adjClose(date,:));
    sumMarketValue.weekly(date)=sum(sharesInStockMarketCap.weekly(date,:).*adjClose(date,:));
    sumOneinEach.weekly(date)=sum(sharesInStockOneinEach.weekly(date,:).*adjClose(date,:));
    sumEqualValue.daily(date)=sum(sharesInStockEqualValue.daily(date,:).*adjClose(date,:));
    sumMarketValue.daily(date)=sum(sharesInStockMarketCap.daily(date,:).*adjClose(date,:));
    sumOneinEach.daily(date)=sum(sharesInStockOneinEach.daily(date,:).*adjClose(date,:));
end
p=[sumEqualValue,sumMarketValue,sumOneinEach];
end


